package net.minecraft.src;

import net.minecraft.client.Minecraft;

import java.util.ArrayList;
import java.util.List;
import java.lang.reflect.Method;

public class EntityClientPlayerMP extends EntityPlayerSP
{

    public EntityClientPlayerMP(Minecraft minecraft, World world, Session session, NetClientHandler netclienthandler)
    {
        super(minecraft, world, session, 0);
        field_9380_bx = 0;
        field_21093_bH = false;
        field_9382_bF = false;
        wasSneaking = false;
        field_12242_bI = 0;
        sendQueue = netclienthandler;
		playerBases = new ArrayList();
        sapi = null;
        portal = -1;
        if(sapi == null)
        {
            sapi = new SAPI();
        }
        playerBases = sapi.PAPIplayerInit(this);
    }

    public void func_4056_N()
    {
        if(field_9380_bx++ == 20)
        {
            sendInventoryChanged();
            field_9380_bx = 0;
        }
        boolean flag = isSneaking();
        if(flag != wasSneaking)
        {
            if(flag)
            {
                sendQueue.addToSendQueue(new Packet19EntityAction(this, 1));
            } else
            {
                sendQueue.addToSendQueue(new Packet19EntityAction(this, 2));
            }
            wasSneaking = flag;
        }
        double d = posX - oldPosX;
        double d1 = boundingBox.minY - field_9378_bz;
        double d2 = posY - oldPosY;
        double d3 = posZ - oldPosZ;
        double d4 = rotationYaw - oldRotationYaw;
        double d5 = rotationPitch - oldRotationPitch;
        boolean flag1 = d1 != 0.0D || d2 != 0.0D || d != 0.0D || d3 != 0.0D;
        boolean flag2 = d4 != 0.0D || d5 != 0.0D;
        if(ridingEntity != null)
        {
            if(flag2)
            {
                sendQueue.addToSendQueue(new Packet11PlayerPosition(motionX, -999D, -999D, motionZ, onGround));
            } else
            {
                sendQueue.addToSendQueue(new Packet13PlayerLookMove(motionX, -999D, -999D, motionZ, rotationYaw, rotationPitch, onGround));
            }
            flag1 = false;
        } else
        if(flag1 && flag2)
        {
            sendQueue.addToSendQueue(new Packet13PlayerLookMove(posX, boundingBox.minY, posY, posZ, rotationYaw, rotationPitch, onGround));
            field_12242_bI = 0;
        } else
        if(flag1)
        {
            sendQueue.addToSendQueue(new Packet11PlayerPosition(posX, boundingBox.minY, posY, posZ, onGround));
            field_12242_bI = 0;
        } else
        if(flag2)
        {
            sendQueue.addToSendQueue(new Packet12PlayerLook(rotationYaw, rotationPitch, onGround));
            field_12242_bI = 0;
        } else
        {
            sendQueue.addToSendQueue(new Packet10Flying(onGround));
            if(field_9382_bF != onGround || field_12242_bI > 200)
            {
                field_12242_bI = 0;
            } else
            {
                field_12242_bI++;
            }
        }
        field_9382_bF = onGround;
        if(flag1)
        {
            oldPosX = posX;
            field_9378_bz = boundingBox.minY;
            oldPosY = posY;
            oldPosZ = posZ;
        }
        if(flag2)
        {
            oldRotationYaw = rotationYaw;
            oldRotationPitch = rotationPitch;
        }
    }

    private void sendInventoryChanged()
    {
    }

    protected void joinEntityItemWithWorld(EntityItem entityitem)
    {
    }

    public void sendChatMessage(String s)
    {
        sendQueue.addToSendQueue(new Packet3Chat(s));
    }

    public void swingItem()
    {
        super.swingItem();
        sendQueue.addToSendQueue(new Packet18Animation(this, 1));
    }

    protected void damageEntity(int i)
    {
        health -= i;
    }

    public void setHealth(int i)
    {
        if(field_21093_bH)
        {
            super.setHealth(i);
        } else
        {
            health = i;
            field_21093_bH = true;
        }
    }

    public void addStat(StatBase statbase, int i)
    {
        if(statbase == null)
        {
            return;
        }
        if(statbase.isIndependent)
        {
            super.addStat(statbase, i);
        }
    }

    public void func_27027_b(StatBase statbase, int i)
    {
        if(statbase == null)
        {
            return;
        }
        if(!statbase.isIndependent)
        {
            super.addStat(statbase, i);
        }
    }

	public boolean attackEntityFrom(Entity entity, int i)
    {
        sapi.PAPIattackEntityFrom(this, entity, i);
        return false;
    }

    public void onDeath(Entity entity)
    {
        if(sapi.PAPIonDeath(this, entity))
        {
            return;
        } else
        {
            super.onDeath(entity);
            return;
        }
    }

    public void updateEntityActionState()
    {
        if(sapi.PAPIupdatePlayerActionState(this))
        {
            return;
        } else
        {
            super.updateEntityActionState();
            return;
        }
    }

    public void moveFlying(float f, float f1, float f2)
    {
        if(sapi.PAPImoveFlying(this, f, f1, f2))
        {
            return;
        } else
        {
            super.moveFlying(f, f1, f2);
            return;
        }
    }

    protected boolean canTriggerWalking()
    {
        return sapi.PAPIcanTriggerWalking(this, true);
    }

    public void handleKeyPress(int i, boolean flag)
    {
        if(sapi.PAPIhandleKeyPress(this, i, flag))
        {
            return;
        } else
        {
            super.handleKeyPress(i, flag);
            return;
        }
    }

    public void writeEntityToNBT(NBTTagCompound nbttagcompound)
    {
        if(sapi.PAPIwriteEntityToNBT(this, nbttagcompound))
        {
            return;
        } else
        {
            super.writeEntityToNBT(nbttagcompound);
            return;
        }
    }

    public void readEntityFromNBT(NBTTagCompound nbttagcompound)
    {
        if(sapi.PAPIreadEntityFromNBT(this, nbttagcompound))
        {
            return;
        } else
        {
            super.readEntityFromNBT(nbttagcompound);
            return;
        }
    }

    public void closeScreen()
    {
        if(sapi.PAPIonExitGUI(this))
        {
            return;
        } else
        {
			sendQueue.addToSendQueue(new Packet101CloseWindow(craftingInventory.windowId));
			inventory.setItemStack(null);
			super.closeScreen();
            return;
        }
    }

    public void displayGUIEditSign(TileEntitySign tileentitysign)
    {
        if(sapi.PAPIdisplayGUIEditSign(this, tileentitysign))
        {
            return;
        } else
        {
            super.displayGUIEditSign(tileentitysign);
            return;
        }
    }

    public void displayGUIChest(IInventory iinventory)
    {
        if(sapi.PAPIdisplayGUIChest(this, iinventory))
        {
            return;
        } else
        {
            super.displayGUIChest(iinventory);
            return;
        }
    }

    public void displayWorkbenchGUI(int i, int j, int k)
    {
        if(sapi.PAPIdisplayWorkbenchGUI(this, i, j, k))
        {
            return;
        } else
        {
            super.displayWorkbenchGUI(i, j, k);
            return;
        }
    }

    public void displayGUIFurnace(TileEntityFurnace tileentityfurnace)
    {
        if(sapi.PAPIdisplayGUIFurnace(this, tileentityfurnace))
        {
            return;
        } else
        {
            super.displayGUIFurnace(tileentityfurnace);
            return;
        }
    }

    public void displayGUIDispenser(TileEntityDispenser tileentitydispenser)
    {
        if(sapi.PAPIdisplayGUIDispenser(this, tileentitydispenser))
        {
            return;
        } else
        {
            super.displayGUIDispenser(tileentitydispenser);
            return;
        }
    }

    public int getPlayerArmorValue()
    {
        return sapi.PAPIgetPlayerArmorValue(this, inventory.getTotalArmorValue());
    }

    public void setEntityDead()
    {
        if(sapi.PAPIsetEntityDead(this))
        {
            return;
        } else
        {
            super.setEntityDead();
            return;
        }
    }

    public double getDistanceSq(double d, double d1, double d2)
    {
        return sapi.PAPIgetDistanceSq(this, d, d1, d2, super.getDistanceSq(d, d1, d2));
    }

    public boolean isInWater()
    {
        return sapi.PAPIisInWater(this, inWater);
    }

    public boolean isSneaking()
    {
        return sapi.PAPIisSneaking(this, movementInput.sneak && !sleeping);
    }

    public float getCurrentPlayerStrVsBlock(Block block)
    {
        return sapi.PAPIgetCurrentPlayerStrVsBlock(this, block, super.getCurrentPlayerStrVsBlock(block));
    }

    public void heal(int i)
    {
        sapi.PAPIheal(this, i);
        return;
    }

    protected boolean pushOutOfBlocks(double d, double d1, double d2)
    {
        if(sapi.PAPIpushOutOfBlocks(this, d, d1, d2))
        {
            return false;
        } else
        {
            return super.pushOutOfBlocks(d, d1, d2);
        }
    }

    public EnumStatus sleepInBedAt(int i, int j, int k)
    {
        EnumStatus enumstatus = sapi.PAPIsleepInBedAt(this, i, j, k);
        return enumstatus != null ? enumstatus : super.sleepInBedAt(i, j, k);
    }

    public float getEntityBrightness(float f)
    {
        return sapi.PAPIgetEntityBrightness(this, f, super.getEntityBrightness(f));
    }

    public void moveEntity(double d, double d1, double d2)
    {
        if(sapi.PAPImoveEntity(this, d, d1, d2))
        {
            return;
        } else
        {
            super.moveEntity(d, d1, d2);
            return;
        }
    }

    public void onUpdate()
    {
        if(!sapi.PAPIonUpdate(this))
        {
            if(!worldObj.blockExists(MathHelper.floor_double(posX), 64, MathHelper.floor_double(posZ)))
			{
				return;
			} else
			{
				super.onUpdate();
				func_4056_N();
				return;
			}
        }
        sapi.PAPIafterUpdate(this);
    }

    public void moveEntityWithHeading(float f, float f1)
    {
        if(sapi.PAPImoveEntityWithHeading(this, f, f1))
        {
            return;
        } else
        {
            super.moveEntityWithHeading(f, f1);
            return;
        }
    }

    public boolean isOnLadder()
    {
        return sapi.PAPIisOnLadder(this, super.isOnLadder());
    }

    public boolean isInsideOfMaterial(Material material)
    {
        return sapi.PAPIisInsideOfMaterial(this, material, super.isInsideOfMaterial(material));
    }

    public void dropCurrentItem()
    {
        if(sapi.PAPIdropCurrentItem(this))
        {
            return;
        } else
        {
			sendQueue.addToSendQueue(new Packet14BlockDig(4, 0, 0, 0, 0));
            return;
        }
    }

    public void dropPlayerItem(ItemStack itemstack)
    {
        if(sapi.PAPIdropPlayerItem(this, itemstack))
        {
            return;
        } else
        {
            super.dropPlayerItem(itemstack);
            return;
        }
    }

    public void onLivingUpdate()
    {
        if(sapi.PAPIonLivingUpdate(this))
        {
            return;
        }
        if(!mc.statFileWriter.hasAchievementUnlocked(AchievementList.openInventory))
        {
            mc.guiAchievement.queueAchievementInformation(AchievementList.openInventory);
        }
        prevTimeInPortal = timeInPortal;
        if(portal != 0)
        {
            DimensionBase dimensionbase = DimensionBase.getDimByNumber(portal);
            if(inPortal)
            {
                if(!worldObj.multiplayerWorld && ridingEntity != null)
                {
                    mountEntity(null);
                }
                if(mc.currentScreen != null)
                {
                    mc.displayGuiScreen(null);
                }
                if(timeInPortal == 0.0F)
                {
                    mc.sndManager.playSoundFX(dimensionbase.soundTrigger, 1.0F, rand.nextFloat() * 0.4F + 0.8F);
                }
                timeInPortal += 0.0125F;
                if(timeInPortal >= 1.0F)
                {
                    timeInPortal = 1.0F;
                    if(!worldObj.multiplayerWorld)
                    {
                        timeUntilPortal = 10;
                        mc.sndManager.playSoundFX(dimensionbase.soundTravel, 1.0F, rand.nextFloat() * 0.4F + 0.8F);
                        DimensionBase.usePortal(portal);
                    }
                }
                inPortal = false;
            } else
            {
                if(timeInPortal > 0.0F)
                {
                    timeInPortal -= 0.05F;
                }
                if(timeInPortal < 0.0F)
                {
                    timeInPortal = 0.0F;
                }
            }
        }
        if(timeUntilPortal > 0)
        {
            timeUntilPortal--;
        }
        movementInput.updatePlayerMoveState(this);
        if(movementInput.sneak && ySize < 0.2F)
        {
            ySize = 0.2F;
        }
        pushOutOfBlocks(posX - (double)width * 0.34999999999999998D, boundingBox.minY + 0.5D, posZ + (double)width * 0.34999999999999998D);
        pushOutOfBlocks(posX - (double)width * 0.34999999999999998D, boundingBox.minY + 0.5D, posZ - (double)width * 0.34999999999999998D);
        pushOutOfBlocks(posX + (double)width * 0.34999999999999998D, boundingBox.minY + 0.5D, posZ - (double)width * 0.34999999999999998D);
        pushOutOfBlocks(posX + (double)width * 0.34999999999999998D, boundingBox.minY + 0.5D, posZ + (double)width * 0.34999999999999998D);
        if(worldObj.difficultySetting == 0 && health < 20 && (ticksExisted % 20) * 12 == 0)
        {
            heal(1);
        }
        inventory.decrementAnimations();
        prevCameraYaw = cameraYaw;
        if(newPosRotationIncrements > 0)
        {
            double d = posX + (newPosX - posX) / (double)newPosRotationIncrements;
            double d1 = posY + (newPosY - posY) / (double)newPosRotationIncrements;
            double d2 = posZ + (newPosZ - posZ) / (double)newPosRotationIncrements;
            double d3;
            for(d3 = newRotationYaw - (double)rotationYaw; d3 < -180D; d3 += 360D) { }
            for(; d3 >= 180D; d3 -= 360D) { }
            rotationYaw = (float)((double)rotationYaw + d3 / (double)newPosRotationIncrements);
            rotationPitch = (float)((double)rotationPitch + (newRotationPitch - (double)rotationPitch) / (double)newPosRotationIncrements);
            newPosRotationIncrements--;
            setPosition(d, d1, d2);
            setRotation(rotationYaw, rotationPitch);
            List list2 = worldObj.getCollidingBoundingBoxes(this, boundingBox.contract(0.03125D, 0.0D, 0.03125D));
            if(list2.size() > 0)
            {
                double d4 = 0.0D;
                for(int k = 0; k < list2.size(); k++)
                {
                    AxisAlignedBB axisalignedbb = (AxisAlignedBB)list2.get(k);
                    if(axisalignedbb.maxY > d4)
                    {
                        d4 = axisalignedbb.maxY;
                    }
                }

                d1 += d4 - boundingBox.minY;
                setPosition(d, d1, d2);
            }
        }
        if(isMovementBlocked())
        {
            isJumping = false;
            moveStrafing = 0.0F;
            moveForward = 0.0F;
            randomYawVelocity = 0.0F;
        } else
        if(!isMultiplayerEntity)
        {
            updateEntityActionState();
        }
        boolean flag = isInWater();
        boolean flag1 = handleLavaMovement();
        if(isJumping)
        {
            if(flag)
            {
                motionY += 0.039999999105930328D;
            } else
            if(flag1)
            {
                motionY += 0.039999999105930328D;
            } else
            if(onGround)
            {
                jump();
            }
        }
        moveStrafing *= 0.98F;
        moveForward *= 0.98F;
        randomYawVelocity *= 0.9F;
        moveEntityWithHeading(moveStrafing, moveForward);
        List list = worldObj.getEntitiesWithinAABBExcludingEntity(this, boundingBox.expand(0.20000000298023221D, 0.0D, 0.20000000298023221D));
        if(list != null && list.size() > 0)
        {
            for(int i = 0; i < list.size(); i++)
            {
                Entity entity = (Entity)list.get(i);
                if(entity.canBePushed())
                {
                    entity.applyEntityCollision(this);
                }
            }

        }
        float f = MathHelper.sqrt_double(motionX * motionX + motionZ * motionZ);
        float f1 = (float)Math.atan(-motionY * 0.20000000298023221D) * 15F;
        if(f > 0.1F)
        {
            f = 0.1F;
        }
        if(!onGround || health <= 0)
        {
            f = 0.0F;
        }
        if(onGround || health <= 0)
        {
            f1 = 0.0F;
        }
        cameraYaw += (f - cameraYaw) * 0.4F;
        cameraPitch += (f1 - cameraPitch) * 0.8F;
        if(health > 0)
        {
            List list1 = worldObj.getEntitiesWithinAABBExcludingEntity(this, boundingBox.expand(1.0D, 0.0D, 1.0D));
            if(list1 != null)
            {
                for(int j = 0; j < list1.size(); j++)
                {
                    Entity entity1 = (Entity)list1.get(j);
                    if(!entity1.isDead)
                    {
                        Method method = null;
                        try
                        {
                            method = (net.minecraft.src.EntityPlayer.class).getDeclaredMethod("j", new Class[] {
                                net.minecraft.src.Entity.class
                            });
                        }
                        catch(Exception exception)
                        {
                            try
                            {
                                method = (net.minecraft.src.EntityPlayer.class).getDeclaredMethod("collideWithPlayer", new Class[] {
                                    net.minecraft.src.Entity.class
                                });
                            }
                            catch(Exception exception2)
                            {
                                exception2.printStackTrace();
                            }
                        }
                        method.setAccessible(true);
                        try
                        {
                            method.invoke(this, new Object[] {
                                entity1
                            });
                        }
                        catch(Exception exception1)
                        {
                            exception1.printStackTrace();
                        }
                    }
                }

            }
        }
    }

    public void respawnPlayer()
    {
        if(sapi.PAPIrespawn(this))
        {
            return;
        } else
        {
		    sendInventoryChanged();
			sendQueue.addToSendQueue(new Packet9Respawn((byte)dimension));
            DimensionBase.respawn(false, 0);
            return;
        }
    }
	
    public NetClientHandler sendQueue;
    private int field_9380_bx;
    private boolean field_21093_bH;
    private double oldPosX;
    private double field_9378_bz;
    private double oldPosY;
    private double oldPosZ;
    private float oldRotationYaw;
    private float oldRotationPitch;
    private boolean field_9382_bF;
    private boolean wasSneaking;
    private int field_12242_bI;
	public ArrayList playerBases;
    private SAPI sapi;
    public int portal;
}
